package com.blzn.blefi.manager;


import com.blzn.blefi.utils.PreferencesUtils;
import com.example.hellojni.BlufiApp;

/**
 * 账户统一管理
 * Created by gh on 2021/11/26.
 */
public class ConfigManager {

    private static final String OTA_FILE_PATH = "ota_file_path";

    private final BlufiApp mApp;

    private ConfigManager() {
        mApp = BlufiApp.getInstance();
    }

    public static ConfigManager getInstance() {
        return ConfigManagerHolder.mInstance;
    }

    public static class ConfigManagerHolder {
        public static ConfigManager mInstance = new ConfigManager();
    }

    public void setOtaFilePath(String pathName) {
        PreferencesUtils.put(mApp, OTA_FILE_PATH, pathName);
    }

    public String getOtaFilePath() {
        return (String) PreferencesUtils.get(mApp, OTA_FILE_PATH, "");
    }

}
