package com.blzn.blefi.ui;

import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.RecyclerView;

import com.blzn.blefi.bus.EventMessage;
import com.blzn.blefi.constants.BleConstants;
import com.blzn.ble.R;

import org.greenrobot.eventbus.EventBus;
import org.greenrobot.eventbus.Subscribe;
import org.greenrobot.eventbus.ThreadMode;

import java.util.Collections;
import java.util.Comparator;
import java.util.LinkedList;
import java.util.List;

import com.blzn.blefi.resultBean.WifiInfo;
import blufi.ble.params.BlufiConfigureParams;
import progressbar.com.progressbarlibrary.PgDialog;

import static blufi.ble.params.BlufiParameter.OP_MODE_STA;
import static com.blzn.blefi.bus.EventCode.A;


public class DateResultActivity extends AppCompatActivity {

    private RecyclerView mRecyclerView;
    private List<WifiInfo> mBleList;
    private BleAdapter mBleAdapter;
    private PgDialog pd;
    private int i = 1;
    private boolean flag;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.blufi_date_result);
        mRecyclerView = findViewById(R.id.recycler_view);
        mBleList = new LinkedList<>();
        mBleAdapter = new BleAdapter();
        mRecyclerView.setAdapter(mBleAdapter);
        if (this.isDestroyed() || this.isFinishing()) {
            return;
        }

        pd = PgDialog.newInstance(this);
        if(!pd.isShowing()){
            pd.show("正在加载中...");//显示加载框
            pd.setData(i);//百分比
        }
        flag = true;
        setTimer();
        //test code
//        mHandler.postDelayed(new Runnable() {
//            @Override
//            public void run() {
//                final BlufiConfigureParams params = new BlufiConfigureParams();
//                params.setStaSSIDBytes("bl_test084".getBytes());
//                params.setStaBSSID("bl_test084");
//                params.setStaPassword("12345678");
//                params.setOpMode(OP_MODE_STA);
//                Intent intent = new Intent();
//                intent.putExtra(BleConstants.KEY_CONFIGURE_PARAM, params);
//                setResult(RESULT_OK, intent);
//                finish();
//            }
//        },3000);
    }
    private void setTimer(){
        mHandler.postDelayed(runnable, 100);
    }

    private Handler mHandler = new Handler();

    Runnable runnable = new Runnable() {
        @Override
        public void run() {
            if (DateResultActivity.this.isDestroyed() || DateResultActivity.this.isFinishing()) {
                return;
            }
            if (flag) {
                mHandler.postDelayed(this, 120);
                //在这里执行定时需要的操作

                i=i+4;
                if (i>100){
                    i=100;
                }
                pd.setData(i);//百分比
            }

        }
    };

    private void stopTimer(){
        flag = false;
    }


    @Override
    protected void onStart() {
        super.onStart();
        EventBus.getDefault().register(this);
    }


    @Override
    protected void onDestroy() {
        super.onDestroy();
        EventBus.getDefault().unregister(this);
        stopTimer();
        if(pd.isShowing()){
            pd.dismiss();
        }
    }


    private class BleHolder extends RecyclerView.ViewHolder implements View.OnClickListener {
        WifiInfo scanResult;
        TextView wifiName;
        TextView wifiMac;
        ImageView imageView;
        ImageView is_lock;

        BleHolder(View itemView) {
            super(itemView);

            is_lock = itemView.findViewById(R.id.is_lock);
            imageView = itemView.findViewById(R.id.rssi);
            wifiName = itemView.findViewById(R.id.wifiName);
            wifiMac = itemView.findViewById(R.id.wifiMac);

            itemView.setOnClickListener(this);
        }

        @Override
        public void onClick(View v) {
            alert_edit(v,scanResult);
        }
    }

    private void alert_edit(View view, final WifiInfo scanResult){
        final EditText et = new EditText(this);
        new AlertDialog.Builder(this).setTitle("请输入"+scanResult.getSsid()+"的密码")
                .setIcon(android.R.drawable.sym_def_app_icon)
                .setView(et)
                .setPositiveButton("确定", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialogInterface, int i) {
                        //按下确定键后的事件
                        Toast.makeText(getApplicationContext(), et.getText().toString(),Toast.LENGTH_LONG).show();
                        final BlufiConfigureParams params = new BlufiConfigureParams();
                        params.setStaSSIDBytes(scanResult.getSsid().getBytes());
                        params.setStaBSSID(scanResult.getBssid());
                        params.setStaPassword(et.getText().toString());
                        params.setOpMode(OP_MODE_STA);
                        Intent intent = new Intent();
                        intent.putExtra(BleConstants.KEY_CONFIGURE_PARAM, params);
                        setResult(RESULT_OK, intent);
                        finish();
                    }
                }).setNegativeButton("取消",null).show();
    }


    private class BleAdapter extends RecyclerView.Adapter<BleHolder> {

        @NonNull
        @Override
        public BleHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
            View view = getLayoutInflater().inflate(R.layout.wifi_item, parent, false);
            return new BleHolder(view);
        }

        @Override
        public void onBindViewHolder(@NonNull BleHolder holder, int position) {
            WifiInfo scanResult = mBleList.get(position);
            holder.scanResult = scanResult;


            holder.wifiName.setText(scanResult.getSsid());
            holder.wifiMac.setText(scanResult.getBssid());
            int rssr_int = scanResult.getRssi();
            if (rssr_int>-25){
                holder.imageView.setImageDrawable(getDrawable(R.drawable.ic_wifi_4));
            }else if (rssr_int<-25&&rssr_int>-50){
                holder.imageView.setImageDrawable(getDrawable(R.drawable.ic_wifi_3));
            }else if (rssr_int<-50&&rssr_int>-70){
                holder.imageView.setImageDrawable(getDrawable(R.drawable.ic_wifi_2));
            }else if (rssr_int<-75){
                holder.imageView.setImageDrawable(getDrawable(R.drawable.ic_wifi_1));
            }

            if (Integer.parseInt(scanResult.getAuth())==0){//open
                holder.is_lock.setImageDrawable(getDrawable(R.drawable.ic_open));
            }else {

            }
        }

        @Override
        public int getItemCount() {
            return mBleList.size();
        }
    }

    @Subscribe(threadMode = ThreadMode.MAIN)
    public void onReceiveMsg(EventMessage message) {
        if (message.getType()==A){
            stopTimer();
            if(pd.isShowing()){
                pd.dismiss();
            }
            WifiInfo wifiInfo = (WifiInfo)message.getMessage();
            mBleList.add(wifiInfo);
            Collections.sort(mBleList, new Comparator<WifiInfo>(){
                public int compare(WifiInfo o1, WifiInfo o2) {
                    return Integer.compare(o2.getRssi(),o1.getRssi());
                }
            });
            mRecyclerView.setItemViewCacheSize(mBleList.size()+1);
            mBleAdapter.notifyDataSetChanged();
            Log.d("getItemCount", String.valueOf(mBleList.size()));
        }
    }
}