package com.blzn.blefi.ui.wight;

import android.content.Context;
import android.os.Build;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.WindowManager;
import android.widget.ImageView;
import android.widget.TextView;

import com.blzn.ble.R;

public class FloatView extends View {

	WindowManager mWManger;
	WindowManager.LayoutParams mWManParams;
	
	public View view;
	
	//初始位置
	private float startX;
	private float startY;
	
	//坐标
	private float x;
	private float y;
	
	//
	private float mTouchSatrtX;
	private float mTouchStartY;
	
	//组件
	public ImageView img_folat,img_close;
	public TextView tv_show;
	
	Context mContext;
	
	public FloatView(Context context) {
		super(context);
		this.mContext = context;
	}

	/**
	 * 初始化mWManger,mWManParams
	 */
	public void show(){
		mWManger = (WindowManager) mContext.getSystemService(Context.WINDOW_SERVICE);
		mWManParams = new WindowManager.LayoutParams();
		if(Build.VERSION.SDK_INT>Build.VERSION_CODES.O){
			mWManParams.type = WindowManager.LayoutParams.TYPE_APPLICATION_OVERLAY;
		}else{
			mWManParams.type= WindowManager.LayoutParams.TYPE_PHONE;
		}

		mWManParams.flags |= WindowManager.LayoutParams.FLAG_NOT_FOCUSABLE;
		//调整悬浮窗到左上角
		mWManParams.gravity = Gravity.TOP|Gravity.LEFT;
		
		//以屏幕左上角为源点，设置x，y
		mWManParams.x = 0;
		mWManParams.y = 0;

		//悬浮窗的长宽数据
//		mWManParams.width = 200;
//		mWManParams.height = 60;
		mWManParams.width = WindowManager.LayoutParams.WRAP_CONTENT;
		mWManParams.height = WindowManager.LayoutParams.WRAP_CONTENT;

		mWManParams.format = -3;//透明
		//加载悬浮窗布局文件
		view = LayoutInflater.from(mContext).inflate(R.layout.traffic_view, null);

		mWManger.addView(view, mWManParams);

		view.setOnTouchListener(new OnTouchListener() {
			/**
			 * 改变悬浮窗位置
			 */
			@Override
			public boolean onTouch(View v, MotionEvent event) {
				x = event.getRawX();
				y = event.getRawY() - 25;
				switch(event.getAction()){
				case MotionEvent.ACTION_DOWN:
					startX = x;
					startY = y;
					mTouchSatrtX = event.getX();
					mTouchStartY = event.getY();
					break;
				case MotionEvent.ACTION_MOVE:
					updatePosition();
					break;
				case MotionEvent.ACTION_UP:
					updatePosition();
					mTouchSatrtX = mTouchStartY =0;
					break;
				}
				return true;
			}
		});
		
		img_close = (ImageView) view.findViewById(R.id.img_close);
		/**
		 * 关闭悬浮窗图标点击事件
		 */
		img_close.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
//				Intent intent = new Intent(mContext,Traffic_Service.class);
//				mContext.stopService(intent);
//				view.setVisibility(View.GONE);
			}
		});
		tv_show = (TextView) view.findViewById(R.id.tv_show);
	}
	
	/**
	 * 更新悬浮窗的位置
	 * 
	 */
	public void updatePosition(){
		mWManParams.x = (int) (x - mTouchSatrtX);
		mWManParams.y = (int) (y - mTouchStartY);
		
		mWManger.updateViewLayout(view, mWManParams);
	}
	/**
	 * 控制关闭悬浮窗按钮的显示与隐藏
	 */
	public void show_img_close() {
		if (Math.abs(x - startX) < 1.5 && Math.abs(y - startY) < 1.5
				&& !img_close.isShown()) {
			img_close.setVisibility(View.VISIBLE);
		} else if (img_close.isShown()) {
			img_close.setVisibility(View.GONE);
		}
	}

	public void removeWindow() {
		mWManger.removeViewImmediate(view);
	}
}