package blufi.ble.params;

public interface BlbleParameter {

    final class Type {
        public final static class CodeLocation {
            public static final int PACKAGE_VALUE = 0x00;

            public static final int SUBTYPE_ACK = 0x00;
            public static final int SUBTYPE_SET_SEC_MODE = 0x01;
            public static final int SUBTYPE_SET_OP_MODE = 0x02;
            public static final int SUBTYPE_CONNECT_WIFI = 0x03;
            public static final int SUBTYPE_DISCONNECT_WIFI = 0x04;
            public static final int SUBTYPE_GET_WIFI_STATUS = 0x05;
            public static final int SUBTYPE_DEAUTHENTICATE = 0x06;
            public static final int SUBTYPE_GET_VERSION = 0x07;
            public static final int SUBTYPE_CLOSE_CONNECTION = 0x08;
            public static final int SUBTYPE_GET_WIFI_LIST = 0x09;
        }

        public final static class ACKCode {

            public static final int SUBTYPE_ACK_SUCCESS = 0x00;
            public static final int SUBTYPE_NOT_READY = 0x01;
            public static final int SUBTYPE_ERROE_TYPE = 0x02;
            public static final int SUBTYPE_CONNECT_WIFI = 0x03;
            public static final int SUBTYPE_DISCONNECT_WIFI = 0x04;
            public static final int SUBTYPE_GET_WIFI_STATUS = 0x05;
            public static final int SUBTYPE_DEAUTHENTICATE = 0x06;
            public static final int SUBTYPE_GET_VERSION = 0x07;
            public static final int SUBTYPE_CLOSE_CONNECTION = 0x08;
            public static final int SUBTYPE_GET_WIFI_LIST = 0x09;
        }

        public final static class WIFI_STATE_ENUM_LIST {
            public static final int WIFI_STATE_UNKNOWN = 0x00;
            public static final int WIFI_STATE_IDLE = 0x01;
            public static final int WIFI_STATE_CONNECTING = 0x02;
            public static final int WIFI_STATE_CONNECTED_IP_GETTING = 0x03;
            public static final int WIFI_STATE_CONNECTED_IP_GOT = 0x04;
            public static final int WIFI_STATE_DISCONNECT = 0x05;
            public static final int WIFI_STATE_WITH_AP_IDLE = 0x11;
            public static final int WIFI_STATE_WITH_AP_CONNECTING = 0x12;
            public static final int WIFI_STATE_WITH_AP_CONNECTED_IP_GETTING = 0x13;
            public static final int WIFI_STATE_WITH_AP_CONNECTED_IP_GOT = 0x14;
            public static final int WIFI_STATE_WITH_AP_DISCONNECT = 0x15;
            public static final int WIFI_STATE_IFDOWN = 0x06;
            public static final int WIFI_STATE_SNIFFER = 0x07;
            public static final int WIFI_STATE_PSK_ERROR = 0x08;
            public static final int WIFI_STATE_NO_AP_FOUND = 0x09;
        }

        ;
    }
}
